﻿/*
 * Copyright (C)  2012  Axel Kesseler
 * 
 * This software is free and you can use it for any purpose. Furthermore, 
 * you are free to copy, to modify and/or to redistribute this software.
 * 
 * In addition, this software is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * 
 */

using System;
using System.IO;
using System.Diagnostics;
using System.Windows.Forms;

namespace plexdata.LineCounter
{
    public class FolderSelectorDialog : ItemSelectorDialog
    {
        public FolderSelectorDialog()
            : base()
        {
            this.Text += " Folders";

            this.Load += this.OnDialogFormLoad;
            this.FormClosed += this.OnDialogFormClosed;
        }

        public FolderSelectorDialog(string basePath)
            : this()
        {
            base.BasePath = basePath;
        }

        public FolderSelectorDialog(string basePath, string[] selectedItems)
            : this(basePath)
        {
            base.SelectedItems = selectedItems;
        }

        #region Dialog form event handlers.

        private void OnDialogFormLoad(object sender, EventArgs args)
        {
            // Don't use FormWindowState for a dialog window!

            // Set size before location because location depends on size!
            this.Size = Settings.Instance.FolderSelectorWindow.Size;
            this.Location = Settings.Instance.FolderSelectorWindow.Location;
        }

        private void OnDialogFormClosed(object sender, FormClosedEventArgs args)
        {
            // Don't use FormWindowState for a dialog window!

            // Set size before location because location depends on size!
            Settings.Instance.FolderSelectorWindow.Size = this.Size;
            Settings.Instance.FolderSelectorWindow.Location = this.Location;
        }

        #endregion // Dialog form event handlers.

        protected override void ScanFolder(string parent)
        {
            if (!String.IsNullOrEmpty(parent))
            {
                foreach (string folder in Directory.GetDirectories(parent))
                {
                    base.AddListItems(folder);
                    this.ScanFolder(folder);
                }
            }
        }
    }
}
