﻿/*
 * Copyright (C)  2012  Axel Kesseler
 * 
 * This software is free and you can use it for any purpose. Furthermore, 
 * you are free to copy, to modify and/or to redistribute this software.
 * 
 * In addition, this software is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * 
 */

using System;

namespace plexdata.LineCounter
{
    public class LiteralScheme : ICloneable
    {
        public LiteralScheme()
            : this(null, null)
        {
        }

        public LiteralScheme(string marker)
            : this(marker, null)
        {
        }

        public LiteralScheme(string marker, string escape)
            : base()
        {
            this.Marker = marker;
            this.Escape = escape;
        }

        private string marker = null;
        public string Marker
        {
            get { return this.marker; }
            set
            {
                if (value == null)
                {
                    value = String.Empty;
                }
                this.marker = value.Trim();
            }
        }

        private string escape = null;
        public string Escape
        {
            get { return this.escape; }
            set
            {
                if (value == null)
                {
                    value = String.Empty;
                }
                this.escape = value.Trim();
            }
        }

        public object Clone()
        {
            return new LiteralScheme(this.Marker, this.Escape);
        }
    }
}
