﻿/*
 * Copyright (C)  2012  Axel Kesseler
 * 
 * This software is free and you can use it for any purpose. Furthermore, 
 * you are free to copy, to modify and/or to redistribute this software.
 * 
 * In addition, this software is distributed in the hope that it will be 
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * 
 */

using System;
using System.Windows.Forms;

namespace plexdata.LineCounter
{
    public partial class ResultPanel : UserControl
    {
        public ResultPanel()
            : base()
        {
            this.InitializeComponent();
        }

        public void Initialize(ScanningResult scanningResult)
        {
            if (scanningResult != null)
            {
                this.barLinesWithCode.Total = scanningResult.TotalLines;
                this.barLinesWithCode.Value = scanningResult.LinesWithCode;

                this.barCommentLines.Total = scanningResult.TotalLines;
                this.barCommentLines.Value = scanningResult.CommentLines;

                this.barEmptyLines.Total = scanningResult.TotalLines;
                this.barEmptyLines.Value = scanningResult.EmptyLines;

                this.panDetailsView.LoadData(scanningResult);
            }
        }

        public void Cleanup()
        {
            this.barLinesWithCode.Total = 0;
            this.barLinesWithCode.Value = 0;

            this.barCommentLines.Total = 0;
            this.barCommentLines.Value = 0;

            this.barEmptyLines.Total = 0;
            this.barEmptyLines.Value = 0;

            this.panDetailsView.ClearData();
        }
    }
}
